---
title: Nápověda pro vývojáře
---

<p>Jednou z charakteristik STM je snadná integrace na web. Existuje hned několik cest, jak se dostat k ukázkám takové integrace:</p>

<ul>
        <li><a href="<%= webPrefix %>/pluginy/webapi.html">WebAPI</a> lze použít pro integraci STM na Váš web.</li>
	<li>V sekci <a href="<%= webPrefix %>/pluginy/sablony.html">Šablony</a> si můžete prohlédnout i stáhnout kódy pro zobrazování různých objektů na vašem webu.</li>
	<li>V aplikaci STM je dostupný modul <a href="<%= webPrefix %>/help/module/export.html">Export</a>, kde si můžete vygenerovat PHP kódy pro vaše konkrétní data.</li>        
</ul>

<h2>Cache - aneb ne pokaždé je třeba přistupovat do databáze</h2>

<p>Výpočty tabulek sezóny, různých statistik nejsou žádné primitivní záležitosti. Proto není zrovna ideální takové výpočty provádět u každého požadavku, tedy při každé návštěvě webu. Třída <a href="api/class-STM.StmCache.html">STM\StmCache</a> nabízí možnost přístupu k tabulkám, statistikám, které budou načteny z cache souboru, pokud mezitím nedošlo v databázi k nějaké změně. Statické metody této třídy:</p>
<table>
    <tr>
        <th>Metoda</th>
        <th>Základní popis</th>
    </tr>
    <tr>
        <td><code class="inline">StmCache::getAllCompetitionMatches($competition)</code></td>
        <td>Všechny zápasy z dané soutěže</td>
    </tr>
    <tr>
        <td><code class="inline">StmCache::getCompetitionPlayerStatistics($competition)</code></td>
        <td>Hráčské statistiky (góly, počet odehraných zápasů, ...) z dané soutěže</td>
    </tr>
    <tr>
        <td><code class="inline">StmCache::getSeasonTable($season)</code></td>
        <td>Tabulky ze sezóny (celková, domácí, hosté)</td>
    </tr>
    <tr>
        <td><code class="inline">StmCache::getTeamsPositionsInTable($season)</code></td>
        <td>Vývoj postavení týmů v tabulce sezóny po jednotlivých kolech</td>
    </tr>
    <tr>
        <td><code class="inline">StmCache::getStatisticsForTeam($team)</code></td>
        <td>Statistiky týmu jako nejvyšší výhry, prohry, seznam odehraných zápasů, ...</td>
    </tr>
    <tr>
        <td><code class="inline">StmCache::getStatisticsForTeamInCompetition($competition, $team)</code></td>
        <td>Statistiky týmu v rámci zvolené soutěže</td>
    </tr>
    <tr>
        <td><code class="inline">StmCache::getTeamMatchesStatistics($selection, $team, $file)</code></td>
        <td>Statistiky pro zvolené zápasy přes <a href="api/class-STM.Match.MatchSelection.html" target="_blank">MatchSelection</a></td>
    </tr>
    <tr>
        <td><code class="inline">StmCache::getUpcomingMatchPreview($team)</code></td>
        <td>Informace o nadcházejícím zápase týmů obsahující vzájemné zápasy, poslední zápasy, ...</td>
    </tr>
</table>

<h2>STM\STMFactory - prostředek pro získávání dat z STM databáze</h2>

<p>Ve verzi 2.0 došlo ke sjednocení načítání dat z DB. Ke každému objektu, který reprezentuje např. 
    nějakou databázovou tabulku, existuje <a href="api/class-STM.Entities.AbstractEntitySelection.html" target="_blank">Selection</a> třída 
    pro definici WHERE podmínek k omezení načítaných dat. Selection třídu pak používá <a href="api/class-STM.Entities.AbstractEntityFactory.html" target="_blank">Factory</a>
    každého objektu. Díky <a href="api/class-STM.StmFactory.html" target="_blank">STM\StmFactory</a> nemusíte
    o těchto třídách nic vědět.</p>
<p>StmFactory poskytuje přístup ke všem dostupným Factory v STM (k vytvoření konkrétní Factory dojde až při prvním
    požadavku). Obsahuje dvě základní metody find a count, které poskytují přístup k Factory, které buď načtou
    objekty nebo pouze spočítá počet řádků v databázi. Viz následující ukázka:</p>
<code><span>// nalezení všech soutěží</span>
$competitions = \STM\StmFactory->find()->Competition->findAll();
<span>// spočítání počtu členů týmů</span>
$teamMembersCount = \STM\StmFactory->count()->TeamMember->findByTeam($team);</code>

<p>Asi nemá smysl vypisovat všechny dostupné Factory metody. Stačí vždy mrknout do <a href="api/class-STM.Entities.AbstractEntityFactory.html" target="_blank">API</a>
    na potomky abstraktní Factory a vždy si vybrat, co potřebuji. Pokud byste chtěli podronější dokumentaci, tak se ozvěte do komentářů.</p>
<p>Pouze výběr zápasů je vzhledem k všemožným podmínkám trochu složitější. Proto připojuji příklad
    kompletního "konfiguračního" pole pro výběr zápasů:</p>
<code>$matchSelection = array(
    'matchType' => \STM\Match\MatchSelection::PLAYED_MATCHES,
    'loadScores' => false,
    'loadPeriods' => false,
    'competition' => 12,
    'teams' => array(1, 2, 3, 5),
    'headToHead' => false,
    'yourTeamsOnly' => false,
    //'seasonRound' => 5,
    //'seasonMaxRound' => 6,
    //'serie' => \STM\StmFactory::find()->PlayoffSerie->findById(1),
    'dates' => array('min' => 'now - 2 years', 'max' => 'now'),
    'limit' => array('max' => 5, 'offset' => 0),
    'order' => array(
        <span>//'orderType' => $isAscending</span>
        'datetime' => true,
        'round' => true,
        'idMatch' => true,
    )
);            
\STM\StmFactory::find()->Match->find($matchSelection);
</code>
<p>V příkladu se budou načítat pouze odehrané zápasy ze soutěže s ID = 12, ve kterých byl alespoň
   jeden z týmů s uvedenými ID. Podmínky pro kola sezóny ani série playoff nejsou aplikovány. Bude načteno prvních 5
   zápasů, které byly odehrány během posledních 2 let. Pořadí bude vzestupně podle data a v případě
   shody dat se poté bude řadit podle čísla kola a nakonec id zápasu.</p>
<p>Doufám, že se mi na příkladu podařil objasnit princip načítání zápasu. V případě dotazů, připomínek
   se neváhejte ozvat! Jedná se o takový stručný výtah, protože nevím, co přesně a jak do podrobna
   bych měl popisovat.</p>